(defun getcadr (filename)
  (let ((err:end-of-file (function (lambda (x (y))(throw 'eof(nreverse ret)))))
	(s (inopen (stream filename)))
	(ret nil))
    (catch 'eof
      (loop (push (cadr (read s)) ret)))))
(defun getcaddr (filename)
  (let ((err:end-of-file (function (lambda (x (y))(throw 'eof(nreverse ret)))))
	(s (inopen (stream filename)))
	(ret nil))
    (catch 'eof
      (loop (push (caddr (read s)) ret)))))
;
(defun sortprim (primlist)
  (sort primlist (function (lambda (p1 p2)
			     (lessp (length (cadr (applykanji p1)))
				    (length (cadr (applykanji p2))))))))
;
(setq primitive '(  ΤΤ ܤ Ƥ  ˤˤ礦  ƤƤ 
                  Τ ľޤ ؤ Τ ˤ ҤΤ  
                  ʤ٤֤ äȤ  줿 Τ α ΤΤ ʤΤ 
                   ޤ β ͤؤ ʤޤ ؤ Τ 
                  β ϤΤ Τ ҤȤ ˤ٤       
                             Ȭ   в   λ 
                  Ĥؤ Ƥؤ ä٤ ˴   ܤβ   
                   Τ ؤ κ ̤κ β Τ ͽβ ؤ 
                  夦ˤ礦 Τ Ĥ ߤĤ Τ  α 
                  Τ ΤΤƤΤΤ   Τؤ 󤺤 ޤ 
                  礦ˤ٤ 狼 Ť Ϥޤ ˤ夦 
                  ݤκ ݤα ΤΤܤ ؤ ĤΤ ޤ α 
                  礦ؤ Τ 󤬤ޤ ޤޤ դŤ β 
                  ĤĤߤޤ դޤ ޤΤ ۤ  κ 
                  Ϥ  ۤŤ β Ҥؤ ޤ  
                  ߤؤ α ۤΤ դߤؤ ؤ ˤޤ  
                  Фͤ Ȥؤ Τ֤ Ҥؤ  ؤ 
                  ޤޤ ˤ礦ˤ礦        ؤ  
                   ޤ ͤΤĤ Τ 󤬤ޤΤΤ ܤ 
                  ޤޤܤ ڤΤΤ ˤ礦 Ѥ ؤ 쾮 κ 
                  Τ դΤ  ޤ ֤α Ǥ äȤؤ 
                  Ƥβ ΤΤĤΤ ξ β ΤϤΤ ̷β 
                  ΤΤ ȯβ   ΤΤ    Τ   
                  ˤ礦 ξ   ŷ ʤؤ  ؤ  
                  ؤ ޤؤ  ͼ    ̦  ʸ       
                                   ð ɬ ɤ 
                    Ƿ ǵ Ⱦ  ̤   Ϳ       ʿ ˤؤ 
                  Ҥؤ ؤ ؤ       β  Ω 
                  Ĥ  ΤΤ ڤβ β Ⱦؤ ޤޤ 
                  β ;β Ȥ ؤ  狼 
                  ؤ ؤ  ˤ礦   ڤˤˤ礦 
                  ΤΤ ϤΤ  פξ α ؤ ؤ α 
                  Τ 쾯 ξΤΤ  κ 
                  狼ˤˤ礦 ȤΤ狼 α 微 
                  ۤΤƤ β ¤β ޤ        
                  ;ؤβ β       β κ ˤ夦 
                  Τؤ ˤŤ ᤹ؤ ޤ ؤ Ҥα 
                  ⤬ޤ ƤƤ ʤκ ߤ κ ޤޤ 
                  Ωؤ Ȥ  ʤ٤֤Τ ؤ ˤ礦 
                  Τۤ ÿα ΤΤ쾮  ά 
                  ʤ狼 Τŷ ˤ礦 ͤۤ  
                  ߤߤؤ ۤۤ ҤĤ β ĤΤȬ ɥؤ 
                  ¶ξ α ɤα äΤĤ ؤ  ʤ 
                  ؤ ؤ  դβ        
                      ʤޤޤ β ΤƤ 
                   ؤ ҤΤܤβ ȤΤͼ ߤߤޤ Ĥα 
                  ˤ Τ˴ α ؤ ξ ΤΤ Ƥβ 
                  ɤޤ ξ ؤ Τ ΩΤΤ ޤޤΤ 
                    ια ʤξ ޤ꤬ ά  
                  άؤ   Ťβ β ξ ϤĤ    
                  Ҳ    ͽ ʺ  ͳ   ǯ ɥ ɹ        
                                      
                  Ĥ ɴ    ̱       ۳ ؤ ξ 
                  षؤ  Ƥ ˤ Τؤ󤽤Τ Ҥؤ β 
                  β κ  ΤĤ ξ ΤΤ  
                  ڤβ ξ β κ  ͤα 콽 ؤ  
                     α      ɿκ Ȥ餫 Ľ 
                  ޤޤ  ̤κ ŵξ Ω狼 
                  ҤĤΤΤ κ ؤ äξ ؤ Ťα դκ 
                  ˤ礦  Ƥξ ߤؤ ̵ξ ɤؤ «ؤ ޤ 
                  ξ ޤα Τ ŸΤĤ ΤĤ ΤΤ Ʀؤ 
                  ݤܤΤΤ ؤ ͤؤ ٤    α 
                  ߤκ α κ  Ϥα Ϥαؤ 
                  ʾκ Ĺؤ ݤΤ ξ Τξ κ  Ȥβ 
                  ξ ۤͤ ӥޤ פ ҤĤȬ ؤ 
                  Ȥؤ ȡ  ξ   Ȥؤ ξ Τ     
                   ʦ Ĺ   « ¿ ­             
                   ɽ    Ϥ ᤫ פˤ礦 Ԥ ζα Ψ 
                  Τ   α      īκ κ 
                  狼 ǣβ Ҥβ Τ Ҥβ ξ ξ 
                  ͤβ ΤĤ  Ȥ꤬ޤ α  Τ 
                  Фα ɤα Ťؤ Τ ˤ礦 ۤβ 礯ؤ  
                  Τˤˤ礦 α β ɤ Ĥ Τ ڤξ 
                  Ϭξ Ϳͽ ͫξ ͤα ǤΤĤ Ȥˤ礦 󤬤ޤ 
                            ɭ      α 
                  ʤ鳭 ¤α  ʥα κ β Ѥκ  
                  ˤ礦 ξ ˤα  ΢β α Ȥۤ    
                   Ť ξ ξ))
(defun make-hira ()
  (do ((i 33 (1+ i))
       (ret))
    ((> i 114)(nreverse ret))
    (sset str 0 (logor 36 128))
    (sset str 1 (logor i 128))
    (princ str)(princ " ")))

